-- Please, see the file LICENSE for copyright and license information.

module HFusion.Internal.HsPrec(
    Precedence,
    LeftParam,
    hpar,      -- :: Bool -> Doc -> Doc
    parentizar, -- ::Precedence -> LeftParam -> Precedence -> Bool
    Asoc(LeftAsoc,RightAsoc,None)
) where

import Text.PrettyPrint

type Precedence = (PrecValue,Asoc) -- Caracteriza un operador.
type LeftParam = Bool   -- Se utiliza para determinar de que lado de
                        -- un operador infijo est un subtrmino.

type PrecValue = Int
data Asoc = LeftAsoc | RightAsoc | None
           deriving (Eq,Show)

-- Inserta parntesis o no, de acuerdo al valor del primer parmetro,
-- utilizando <> delante y detrs de la expresin en el segundo 
-- parmetro.
hpar:: Bool -> Doc -> Doc
hpar paren d = if paren then char '(' <> d <> char ')'
                        else d

-- Decide si una expresin E2, cuyo operador O2 ms externo tiene la 
-- precedencia dada en el tercer parmetro, necesita ser parentizada,
-- siendo el primer parmetro la precedencia del operador O1 del cul E2
-- es subexpresin, y el segundo parmetro indica si E2 se halla a la 
-- izquierda de O1.
-- parentizar (1,LeftAsoc) False (1,_) -> True
parentizar::Precedence -> LeftParam -> Precedence -> Bool
parentizar (p0,a0) left (p1,_) = (p0>p1)||
                                 (p0==p1)&&(if left then (a0==RightAsoc)
                                                    else (a0==LeftAsoc)) 

